<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { computed, onBeforeUnmount, onMounted, ref } from 'vue';
import { storeToRefs } from 'pinia';
import type { post as SchedulePost} from '@/types/schedule';
import type { element as FreeformPost} from '@/types/freeform';
import type { element as TimelinePost} from '@/types/timeline';
import { useScheduleStore } from '@/stores/schedule';
import { userType } from '@/enums/enums';
import Embedded from '@/components/general/Embedded.vue';
import TextView from '@/components/general/TextView.vue';
import LikeButton from '@/components/general/LikeButton.vue';
import { Dialog, DialogPanel } from '@headlessui/vue';
import { useFreeformStore } from '@/stores/freeform';
import { useTimelineStore } from '@/stores/timeline';
import CommentSidebar from '@/components/general/CommentSidebar.vue';

const props = defineProps<{
    post: SchedulePost | FreeformPost | TimelinePost,
    type: "Schedule" | "Freeform" | "Timeline",
    inert: boolean,
    postIndex: number,
    columnIndex?: number
}>()

const store = props.type === "Schedule" ? useScheduleStore() : props.type === "Freeform" ? useFreeformStore() : useTimelineStore();
//@ts-ignore
const { getCommentsAllowed, getStyle, getUserType, postIndex, columnIndex } = storeToRefs(store);
const getLikesAllowed = props.type !== "Freeform"? storeToRefs(store).getLikesAllowed : false;
const showComments = ref(false);

const emits = defineEmits<{
    (e: 'close'):void,
    (e: 'like'):void,
    (e: 'comments'):void,
    (e: 'visibility', value:boolean):void
}>();

const handleClose = ()=>{
    emits('close');
};

const handleLike = ()=>{
    emits('like');
};

const handleOpenComments = ()=>{
    //handleClose();
    //emits('comments');
    postIndex.value = props.postIndex;
    if(props.columnIndex)
        columnIndex.value = props.columnIndex;
    showComments.value = true;
};

const handleCloseComments = ()=>{
    postIndex.value = -1;
    if(props.columnIndex)
        columnIndex.value = -1;
    showComments.value = false;
};

const handleVisibility = ()=>{
    emits('visibility', true);
};

const getCommentsLength = computed(() => {
    if (getUserType.value === userType.ADMIN || getUserType.value === userType.MODERATOR) {
        return props.post.comments.length;
    } else {
        return props.post.comments.filter((comment: any) => comment.visible).length;
    }
});

const isOpen = ref(false);
onMounted(() => {
    isOpen.value = true;
})

onBeforeUnmount(() => {
    isOpen.value = false;
});

const getFont = getStyle.value.font;
</script>
<template>
    <Dialog :open="isOpen" class="relative z-[999]" as="div" :inert="inert">
        <div aria-hidden="true" class="fixed inset-0 bg-black/50"></div>
        <div class="fixed inset-0 flex justify-center">
            <DialogPanel as="div" class="relative ml-auto mr-auto mb-auto top-12 w-[720px] max-w-full rounded-xl max-h-[calc(100dvh-6em)] bg-white"
                :class="[getFont ? getFont : '']" :style="{ background: post.color }">
                <div class="">
                    <div class="flex flex-row text-2xl px-2">
                        <h2 class="" v-if="post.title.headline" v-html="post.title.headline"></h2>
                        <div class="ml-auto">
                            <Tooltip :tooltip="$t('general.buttons.close')">
                                <button class="w-8 h-8 hover:bg-gray-100 rounded-md" @click="handleClose"><i class="ri-close-line"></i></button>
                            </Tooltip>
                        </div>
                    </div>
                    <div class="max-h-[calc(100dvh-19em)] overflow-auto">
                        <div class=" text-gray-500 flex flex-col gap-1 text-2xl">
                            <div class="" v-if="post.body">
                                <Embedded class="w-full" :key="post.title.post" :body="post.body" :url="post.title.post"
                                    fontSize="" :info="post.info" topbarClass=""
                                    v-if="post.title.post && post.title.post.length > 0" />
                            </div>
                            <div class="" v-else>
                                <TextView fontSize="" :content="post.title.post"
                                    :font-style="getStyle?.font ? getStyle.font : ''" :content-length="-1" />
                            </div>
                        </div>
                    </div>
                </div>
                <div class="px-4 py-4 flex rounded-b-xl justify-between p-1" :class="type==='Freeform'?'flex-row-reverse':'flex-row'" v-if="(getLikesAllowed || getCommentsAllowed) && post.authorized">
                    <div class="w-fit">
                        <LikeButton :likes="post.likes" :likeSymbol="getStyle.likeSymbol" @click="handleLike"
                            v-if="getLikesAllowed && 'likes' in post" />
                    </div>
                    <div class="w-fit">
                        <Tooltip :tooltip="$t('tooltips.unhide')" v-if="(getUserType !== userType.USER && !post.visible)">
                            <button class="size-7 p-1 hover:bg-gray-100" @click="handleVisibility"><i
                                    class="ri-eye-off-line leading-5 text-[20px] text-teal-500"></i></button>
                        </Tooltip>
                    </div>
                    <div class="w-fit">
                        <Tooltip :tooltip="$t('contentPage.comment.label.pl')" v-if="getCommentsAllowed">
                            <button class="h-7 p-1 hover:bg-gray-100 select-none flex flex-row rounded-md" @click="handleOpenComments">
                                <i class="ri-discuss-line leading-5 text-[20px]" v-if="type==='Freeform'"></i>
                                <span class="text-xs leading-7 align-bottom"
                                    v-if="getCommentsLength <= 99 && getCommentsLength > 0">{{
                                    getCommentsLength }}</span>
                                <span class="text-xs leading-7 align-bottom" v-else-if="getCommentsLength > 99">99+</span>
                                <i class="ri-discuss-line leading-5 text-[20px]" v-if="type!=='Freeform'"></i>
                            </button>
                        </Tooltip>
                    </div>
                </div>
                <CommentSidebar v-if="showComments" @close="handleCloseComments"/>
            </DialogPanel>
        </div>
    </Dialog>
</template>